"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
const core_1 = require('@angular/core');
const primeng_1 = require('primeng/primeng');
const tree_manager_1 = require('../services/tree-manager');
const node_search_1 = require('../pipes/node-search');
const ng2_xeditable_text_directive_1 = require('../ng2-xeditable-text.directive');
let TreeNode_1;
let TreeNode = TreeNode_1 = class TreeNode {
    constructor(treeManager) {
        this.treeManager = treeManager;
        this.askedChildDeletion = new core_1.EventEmitter();
    }
    addNewNode(node) {
        node.subNodes = [...node.subNodes, this.treeManager.getNewNode()];
        node.expanded = true;
    }
    hasChevronDown(child) {
        return child.subNodes.length != 0 && child.expanded;
    }
    hasChevronRight(child) {
        return child.subNodes.length != 0 && !child.expanded;
    }
    onDragStart(event, child) {
        this.treeManager.setSelectedNode(child);
    }
    onDragEnd(event, child) {
        if (this.treeManager.getHasDropped()) {
            this.treeManager.setHasDropped(false);
            this.children.splice(this.children.indexOf(child), 1);
        }
    }
    deleteNode(node) {
        this.children.splice(this.children.indexOf(node), 1);
    }
    getFilteredText() {
        this.treeManager.getFilteredText();
    }
    onDrop(event, node) {
        if (this.treeManager.getSelectedNode() != node) {
            this.treeManager.setHasDropped(true);
            node.subNodes = [...node.subNodes, this.treeManager.getSelectedNode()];
        }
    }
    toggle(child) {
        child.expanded = !child.expanded;
    }
};
__decorate([
    core_1.Input(), 
    __metadata('design:type', Object)
], TreeNode.prototype, "children", void 0);
__decorate([
    core_1.Input('custom-classes'), 
    __metadata('design:type', Object)
], TreeNode.prototype, "customClasses", void 0);
__decorate([
    core_1.Output(), 
    __metadata('design:type', Object)
], TreeNode.prototype, "askedChildDeletion", void 0);
TreeNode = TreeNode_1 = __decorate([
    core_1.Component({
        selector: 'tree-node',
        directives: [primeng_1.Draggable, primeng_1.Droppable, TreeNode, ng2_xeditable_text_directive_1.XEditableText],
        template: require('./tree-node.html'),
        styles: [require('./tree-node.css')],
        pipes: [node_search_1.NodeSearch]
    }), 
    __metadata('design:paramtypes', [tree_manager_1.TreeManager])
], TreeNode);
exports.TreeNode = TreeNode;
